(function () {

    'use strict';

    function runGame (gameName,data) {
        //wanba begin
        console.log("on startGame");
 
        var allSettings = [];
 
        if(data.dependPluginList){
            for (var i = data.dependPluginList.length - 1; i >= 0; i--) {
                var plugin = data.dependPluginList[i];
                var targetPath  = plugin.pluginName + plugin.version;
                var projectJS = targetPath + '/src/project.js';
                require(projectJS);
                cc.addScriptToUnload(projectJS);
 
                var settingsJS = targetPath + '/src/settings.js';
                require(settingsJS);
                cc.addScriptToUnload(settingsJS);
                allSettings.push(window._CCSettings);
                window._CCSettings = undefined;
 
            }
            
        }
 
        var gameRoot = gameName +"/";

        console.log("require settings.js ...");
        require(gameName +'/src/settings.js');
 
        allSettings.push(window._CCSettings);
 
        cc.flag_audio_channel = 0;
        //wanba end

        var settings = window._CCSettings;
        window._CCSettings = undefined;
 
        if(allSettings.length >= 2){ //代表启动时候有插件
            settings = cc.deepmerge.all(allSettings);
        }

        if ( !settings.debug ) {
            var uuids = settings.uuids;

            var rawAssets = settings.rawAssets;
            var assetTypes = settings.assetTypes;
            var realRawAssets = settings.rawAssets = {};
            for (var mount in rawAssets) {
                var entries = rawAssets[mount];
                var realEntries = realRawAssets[mount] = {};
                for (var id in entries) {
                    var entry = entries[id];
                    var type = entry[1];
                    // retrieve minified raw asset
                    if (typeof type === 'number') {
                        entry[1] = assetTypes[type];
                    }
                    // retrieve uuid
                    realEntries[uuids[id] || id] = entry;
                }
            }

            var scenes = settings.scenes;
            for (var i = 0; i < scenes.length; ++i) {
                var scene = scenes[i];
                if (typeof scene.uuid === 'number') {
                    scene.uuid = uuids[scene.uuid];
                }
            }

            var packedAssets = settings.packedAssets;
            for (var packId in packedAssets) {
                var packedIds = packedAssets[packId];
                for (var j = 0; j < packedIds.length; ++j) {
                    if (typeof packedIds[j] === 'number') {
                        packedIds[j] = uuids[packedIds[j]];
                    }
                }
            }
        }

        console.log("init onStart ...");
        var onStart = function () {
            cc.view.resizeWithBrowserSize(true);
            // UC browser on many android devices have performance issue with retina display
            if (cc.sys.os !== cc.sys.OS_ANDROID || cc.sys.browserType !== cc.sys.BROWSER_TYPE_UC) {
                cc.view.enableRetina(true);
            }
            //cc.view.setDesignResolutionSize(settings.designWidth, settings.designHeight, cc.ResolutionPolicy.SHOW_ALL);

            if (cc.sys.isMobile) {
                if (settings.orientation === 'landscape') {
                    cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
                }
                else if (settings.orientation === 'portrait') {
                    cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
                }
                // qq, wechat, baidu
                cc.view.enableAutoFullScreen(
                    cc.sys.browserType !== cc.sys.BROWSER_TYPE_BAIDU &&
                    cc.sys.browserType !== cc.sys.BROWSER_TYPE_WECHAT &&
                    cc.sys.browserType !== cc.sys.BROWSER_TYPE_MOBILE_QQ
                );
            }

            console.log("init AssetLibrary ...");
            // init assets
            cc.AssetLibrary.init({
                libraryPath: gameRoot +'res/import',
                rawAssetsBase: gameRoot + 'res/raw-',
                rawAssets: settings.rawAssets,
                packedAssets: settings.packedAssets,
                md5AssetsMap: settings.md5AssetsMap
            });

            console.log("notification js game start game ...");
            cc.director.notificationJsGame("COCOS_GAME_START",data);
        };

        require(gameName +'/src/project.js');
        var option = {
            //width: width,
            //height: height,
            id: 'GameCanvas',
            scenes: settings.scenes,
            debugMode: settings.debug ? cc.DebugMode.INFO : cc.DebugMode.ERROR,
            showFPS: false,
            frameRate: 30,
            jsList: [],
            groupList: settings.groupList,
            collisionMatrix: settings.collisionMatrix,
            renderMode: 0
        };

        cc.game.run(option, onStart);
    }


    cc.reportedError = {};
    window.__errorHandler = function(file, line, type, stack){
        if(!cc.remoteLogCooldown || (cc.remoteLogCooldown < new Date().getTime() - 5000)){
            cc.remoteLogCooldown = new Date().getTime();

            var reportKey = file + line + type;
            console.log("CocosError:", reportKey);
            if (cc.reportedError[reportKey] == undefined) {
                var msg = "file:" + file + " line:" + line + " " + type;
                console.log("remoteLog", msg);
                cc.native.remoteLog({
                    game_name:cc.gameName,
                    cocos_event:"onCocosError",
                    msg: msg,
                    stack: stack,
                });

                cc.reportedError[reportKey] = msg;
            }

        }
    }

    console.log("init flags ...");
    cc.flag_blend_fix = false; //fix blend func
    cc.flag_download_fix = true;
    cc.flag_close_log = true;
    cc.flag_show_version = false;
    cc.flag_audio_channel = 0; //0: cocos 1:Arigo 2:native

    if (cc.flag_close_log) {
        console.log = function() {};
    }
    
    var downloadPath = jsb.fileUtils.getWritablePath()+ "cocos/games";
    if(cc.sys.os === cc.sys.OS_ANDROID){ // android 资源目录
        downloadPath = jsb.fileUtils.getWritablePath();
    }
    console.log("add searchPath:", downloadPath);
    jsb.fileUtils.addSearchPath(downloadPath, true);

    console.log("require jsb_polyfill.js ...");
    require('src/jsb_polyfill.js');

    console.log("require Fetch.js...");
    require('src/Fetch.js');
 
    console.log("require deepmerge.js");
    require('src/deepmerge.js');
 
    console.log("require native.js ...");
    require('src/native.js');
 
    cc.classConstructors = {};
    
    cc.setConstructors = function(id,constructor){
        cc.classConstructors[id] = constructor;
        console.log("RegistConstructor:", id);
    }
    cc.unSetConstructors = function(){
        for(var key in cc.classConstructors){
            console.log("UnRegistConstructor:", key);
            cc.js.unregisterClass(cc.classConstructors[key]);
        }
        cc.classConstructors = {};
    }

    cc.plugins = {};
    cc.scriptNeedToUnload = [];
 
    cc.addScriptToUnload = function(file) {
        console.log("addScriptToUnload:", file);
        cc.scriptNeedToUnload.push(file);
    },
 
    cc.unloadScripts = function() {
        for(let i = 0, length = cc.scriptNeedToUnload.length; i < length; i ++) {
            console.log("unloadScripts:", cc.scriptNeedToUnload[i]);
            cc.sys.cleanScript(cc.scriptNeedToUnload[i]);
        }
        cc.scriptNeedToUnload.length = 0;
        cc.plugins = {};
    }
    
    console.log("init notificationJs ...");
    cc.director.notificationJs = function(eventName, data) {
        console.log("notificationJs", eventName, data);
        var data = JSON.parse(data);

        if (eventName == "COCOS_GAME_START") {
            console.log("cc.director.notificationJs COCOS_GAME_START," + data.gameName);
            runGame(data.gameName, data);
        } else {
            if (cc.director.notificationJsGame) {
                cc.director.notificationJsGame(eventName, data);
            } else {
                console.log("cc.director.notificationJsGame is null");
            }
        }
    }

    if (cc.sys.os === cc.sys.OS_ANDROID && cc.director.notificationNative) {
        cc.director.notificationNative("COCOS_ANDROID_LOADED", "{}");
    }

    if (cc.sys.os === cc.sys.OS_IOS && cc.director.notificationNative) {
        cc.director.notificationNative("COCOS_IOS_LOADED","{}");
    }

})();
